diff -uNrd ircd-hybrid-6.3.1.dist/src/m_oper.c ircd-hybrid-6.3.1/src/m_oper.c
--- ircd-hybrid-6.3.1.dist/src/m_oper.c	Sat Dec  8 02:06:13 2001
+++ ircd-hybrid-6.3.1/src/m_oper.c	Mon Apr 21 16:02:11 2003
@@ -231,14 +231,13 @@
             }
         }
 
+      if (IsSetOperAdmin(sptr))
+        sptr->umodes |= FLAGS_ADMIN;
+
       fdlist_add(sptr->fd, FDL_OPER | FDL_BUSY);
-#ifdef CUSTOM_ERR
-      sendto_ops("%s (%s@%s) has just acquired the personality of a petty megalomaniacal tyrant [IRC(%c)p]", parv[0],
-#else
       sendto_ops("%s (%s@%s) is now operator (%c)", parv[0],
-#endif /* CUSTOM_ERR */
                  sptr->username, sptr->host,
-                 IsOper(sptr) ? 'O' : 'o');
+                 oper_type_char(sptr));
       send_umode_out(cptr, sptr, old);
       sendto_one(sptr, form_str(RPL_YOUREOPER), me.name, parv[0]);
       sendto_one(sptr, ":%s NOTICE %s :*** Oper privs are %s",me.name,parv[0],
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_operwall.c ircd-hybrid-6.3.1/src/m_operwall.c
--- ircd-hybrid-6.3.1.dist/src/m_operwall.c	Wed Oct 17 11:13:31 2001
+++ ircd-hybrid-6.3.1/src/m_operwall.c	Sat Apr 19 21:06:45 2003
@@ -118,7 +118,7 @@
 
   sendto_serv_butone(IsServer(cptr) ? cptr : NULL, ":%s OPERWALL :%s",
                      parv[0], message);
-  send_operwall(sptr, "OPERWALL", message);
+  send_operwall(sptr, "OPERWALL", message, 0);
   return 0;
 }
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_pong.c ircd-hybrid-6.3.1/src/m_pong.c
--- ircd-hybrid-6.3.1.dist/src/m_pong.c	Thu Nov 29 01:44:29 2001
+++ ircd-hybrid-6.3.1/src/m_pong.c	Sat Apr 19 21:06:45 2003
@@ -28,6 +28,7 @@
 #include "numeric.h"
 #include "send.h"
 #include "channel.h"
+#include "s_stats.h"
 #include "irc_string.h"
 
 #ifdef DEBUGMODE
@@ -139,6 +140,35 @@
       if (MyConnect(sptr))
       {
         sptr->flags &= ~FLAGS_PINGSENT;
+#ifdef ANTI_IP_SPOOF
+  /* ANTI_IP_SPOOF delays the registration of a local client until after we
+     have received a response from a PING containing a random integer.  When
+     we receive the resulting PONG, then we register the client.
+  */
+
+  if(MyConnect(sptr) && !IsRegisteredUser(sptr) && sptr->random_ping) {
+      unsigned int received_random_ping;
+      received_random_ping = strtoul(origin, (char **)NULL, 10);
+
+      if(received_random_ping) {
+          /* Ensure that aClient has a user and a nick (redundant) */
+          if((sptr->user) && (sptr->name[0])) {
+              if(received_random_ping == sptr->random_ping) {
+                  char buf[USERLEN + 1];
+                  strncpy_irc(buf, sptr->username, USERLEN);
+                  buf[USERLEN] = '\0';
+
+                  sptr->flags2 |= FLAGS2_GOT_ANTI_SPOOF_PING;
+                  register_user(cptr, sptr, sptr->name, buf);
+                  return 0;
+              } else {
+                 ServerStats->is_ipspoof++;
+                 return exit_client(cptr,sptr,&me,"Wrong random PONG response.");
+              }
+          }
+      }
+  }
+#endif
 #ifdef NEED_SPLITCODE
 #ifdef SPLIT_PONG
         if (IsServer(sptr))
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_quit.c ircd-hybrid-6.3.1/src/m_quit.c
--- ircd-hybrid-6.3.1.dist/src/m_quit.c	Sat Dec  8 02:06:14 2001
+++ ircd-hybrid-6.3.1/src/m_quit.c	Fri May  2 11:38:08 2003
@@ -29,6 +29,7 @@
 #include "s_serv.h"
 #include "send.h"
 #include <string.h>
+#include <stdio.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -98,10 +99,20 @@
                char *parv[])
 {
   char *comment = (parc > 1 && parv[1]) ? parv[1] : cptr->name;
+#ifdef CLIENT_EXIT
+  char reason[TOPICLEN];
+#endif
 
   sptr->flags |= FLAGS_NORMALEX;
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
+
+#ifdef CLIENT_EXIT
+  if (!IsServer(sptr) && MyConnect(sptr)) {
+    snprintf(reason, TOPICLEN, "Quit: %s", comment);
+    comment = reason;
+  }
+#endif
 
 #ifdef ANTI_SPAM_EXIT_MESSAGE
   if( !IsServer(sptr) && MyConnect(sptr) &&
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_rehash.c ircd-hybrid-6.3.1/src/m_rehash.c
--- ircd-hybrid-6.3.1.dist/src/m_rehash.c	Thu Dec  6 23:51:34 2001
+++ ircd-hybrid-6.3.1/src/m_rehash.c	Mon Apr 21 16:03:15 2003
@@ -117,11 +117,7 @@
       if (irccmp(parv[1],"DNS") == 0)
         {
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "DNS");
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is rehashing DNS while whistling innocently",
-#else
           sendto_ops("%s is rehashing DNS",
-#endif
                  parv[0]);
           restart_resolver();   /* re-read /etc/resolv.conf AGAIN?
                                    and close/re-open res socket */
@@ -137,12 +133,7 @@
 		    }
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "temp klines");
           flush_temp_klines();
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is clearing temp klines while whistling innocently",
-#else
-          sendto_ops("%s is clearing temp klines",
-#endif
-                 parv[0]);
+          sendto_ops("%s is clearing temp klines", parv[0]);
           found = YES;
         }
 #ifdef GLINES
@@ -158,12 +149,7 @@
 
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "g-lines");
           flush_glines();
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is clearing G-lines while whistling innocently",
-#else
-          sendto_ops("%s is clearing G-lines",
-#endif
-                 parv[0]);
+          sendto_ops("%s is clearing G-lines", parv[0]);
           found = YES;
         }
 #endif
@@ -171,12 +157,7 @@
         {
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "garbage collecting");
           block_garbage_collect();
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is garbage collecting while whistling innocently",
-#else
-          sendto_ops("%s is garbage collecting",
-#endif
-                 parv[0]);
+          sendto_ops("%s is garbage collecting", parv[0]);
           found = YES;
         }
       else if(irccmp(parv[1],"MOTD") == 0)
@@ -208,12 +189,7 @@
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0],
                      ConfigFileEntry.configfile);
           /* this does a full rehash right now, so report it as such */
-#ifdef CUSTOM_ERR
-          sendto_ops("%s is rehashing dlines from server config file while whistling innocently",
-#else
-          sendto_ops("%s is rehashing dlines from server config file",
-#endif
-                     parv[0]);
+          sendto_ops("%s is rehashing dlines from server config file", parv[0]);
           log(L_NOTICE, "REHASH From %s\n", get_client_name(sptr, HIDE_IP));
           dline_in_progress = 1;
           return rehash(cptr, sptr, 0);
@@ -228,11 +204,12 @@
         {
 #ifdef GLINES
           sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GLINES, GC, HELP, MOTD, OMOTD, DUMP, DLINES",
-	                 me.name, sptr->name);
+                         me.name, sptr->name);
 #else
-          sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GC, HELP, MOTD, OMOTD, DUMP, DLINES", 
-	                 me.name, sptr->name);
+          sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GC, HELP, MOTD, OMOTD, DUMP, DLINES",
+                         me.name, sptr->name);
 #endif
+
           return(0);
         }
     }
@@ -240,12 +217,7 @@
     {
       sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0],
                  ConfigFileEntry.configfile);
-#ifdef CUSTOM_ERR
-      sendto_ops("%s is rehashing server config file while whistling innocently",
-#else
-      sendto_ops("%s is rehashing server config file",
-#endif
-                 parv[0]);
+      sendto_ops("%s is rehashing server config file", parv[0]);
       log(L_NOTICE, "REHASH From %s\n", get_client_name(sptr, SHOW_IP));
       return rehash(cptr, sptr, 0);
     }
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_server.c ircd-hybrid-6.3.1/src/m_server.c
--- ircd-hybrid-6.3.1.dist/src/m_server.c	Sun Jun 17 19:51:21 2001
+++ ircd-hybrid-6.3.1/src/m_server.c	Sat Apr 19 21:06:45 2003
@@ -437,8 +437,10 @@
                          
         }
       
-      sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
-                           acptr->name, sptr->name);
+      sendto_realops_flags(FLAGS_EXTERNAL,
+                           "Server %s being introduced by %s (%d %s)",
+                           acptr->name, sptr->name, acptr->hopcount,
+                           acptr->info);
       return 0;
     }
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_set.c ircd-hybrid-6.3.1/src/m_set.c
--- ircd-hybrid-6.3.1.dist/src/m_set.c	Thu Dec 13 18:50:45 2001
+++ ircd-hybrid-6.3.1/src/m_set.c	Sat Apr 19 21:06:45 2003
@@ -116,6 +116,10 @@
  * to the set table, you must increase TOKEN_BAD so that it is directly
  * after the last valid entry.
  * -Hwy
+ *
+ * +fr extension...
+ * CLONENUM = 14, CLONEPERIOD = 15, MAXTKTIME = 16,
+ * XLINETYPE = 17, TOKEN_BAD = 18
  */
 
 #define TOKEN_MAX 0
@@ -132,7 +136,11 @@
 #define TOKEN_SPAMNUM 11
 #define TOKEN_SPAMTIME 12
 #define TOKEN_LOG 13
-#define TOKEN_BAD 14
+#define TOKEN_CLONENUM 14
+#define TOKEN_CLONEPERIOD 15
+#define TOKEN_MAXTKTIME 16
+#define TOKEN_XLINETYPE 17
+#define TOKEN_BAD 18
 
 static char *set_token_table[] = {
   "MAX",
@@ -149,6 +157,10 @@
   "SPAMNUM",
   "SPAMTIME",
   "LOG",
+  "CLONENUM",
+  "CLONEPERIOD",
+  "MAXTKTIME",
+  "XLINETYPE",
   NULL
 };
 
@@ -579,6 +591,123 @@
           return 0;
           break;
 
+#ifdef CHECK_CLONE
+          case TOKEN_CLONENUM:
+            if(parc > 2)
+              {
+                int newval = atoi(parv[2]);
+
+                if(newval < 1)
+                  {
+                    sendto_one(sptr, ":%s NOTICE %s :CLONENUM must be >= 1",
+                               me.name, parv[0]);
+                    return 0;
+                  }
+                sendto_realops("%s has changed CLONENUM to %i",
+                               parv[0], newval);
+                GlobalSetOptions.clone_num = newval;
+              }
+            else
+              {
+                sendto_one(sptr, ":%s NOTICE %s :CLONENUM is currently %i",
+                           me.name,
+                           parv[0],
+                           GlobalSetOptions.clone_num);
+              }
+            return 0;
+            break;
+          case TOKEN_CLONEPERIOD:
+            if(parc > 2)
+              {
+                int newval = atoi(parv[2]);
+
+                if(newval < 1)
+                  {
+                    sendto_one(sptr, ":%s NOTICE %s :CLONEPERIOD must be >= 1",
+                               me.name, parv[0]);
+                    return 0;
+                  }
+                sendto_realops("%s has changed CLONEPERIOD to %i",
+                               parv[0], newval);
+                GlobalSetOptions.clone_period = newval;
+              }
+            else
+              {
+                sendto_one(sptr, ":%s NOTICE %s :CLONEPERIOD is currently %i",
+                           me.name,
+                           parv[0],
+                           GlobalSetOptions.clone_period);
+              }
+            return 0;
+            break;
+#else
+        case TOKEN_CLONENUM:
+            break;
+        case TOKEN_CLONEPERIOD:
+            break;
+#endif /* CHECK_CLONE */
+
+        case TOKEN_MAXTKTIME:
+          if(parc > 2)
+            {
+              int newval = atoi(parv[2]);
+
+              if(newval <= 0)
+                {
+                  sendto_one(sptr, ":%s NOTICE %s :MAXTKTIME must be > 0",
+                             me.name, parv[0]);
+                  return 0;
+                }
+              MAXTKTIME = newval;
+              sendto_realops("%s has changed MAXTKTIME to %i",
+                             parv[0], MAXTKTIME);
+            }
+          else
+            {
+              sendto_one(sptr, ":%s NOTICE %s :MAXTKTIME is currently %i",
+                         me.name, parv[0], MAXTKTIME);
+            }
+          return 0;
+          break;
+
+        case TOKEN_XLINETYPE:
+#ifdef XLINE_COMMAND
+          if(parc > 2)
+            {
+              if(!irccmp(parv[2],"WARN"))
+                {
+                  sendto_realops("%s has changed XLINETYPE to WARN", parv[0]);
+                  GlobalSetOptions.xlinetype = 0;
+                }
+              else if (!irccmp(parv[2],"REJECT"))
+                {
+                  sendto_realops("%s has changed XLINETYPE to REJECT", parv[0]);
+                  GlobalSetOptions.xlinetype = 1;
+                }
+              else if (!irccmp(parv[2],"SILENT"))
+                {
+                  sendto_realops("%s has changed XLINETYPE to SILENT", parv[0]);
+                  GlobalSetOptions.xlinetype = 2;
+                }
+              else
+                {
+                  sendto_one(sptr, ":%s NOTICE %s :XLINETYPE settings:  WARN, "
+                             "REJECT, SILENT", me.name, parv[0]);
+                }
+            }
+          else
+            {
+              sendto_one(sptr, ":%s NOTICE %s :XLINETYPE is currently %s",
+                         me.name, parv[0],
+                         (GlobalSetOptions.xlinetype == 0) ? "WARN" :
+                         (GlobalSetOptions.xlinetype == 1) ? "REJECT" :
+                         "SILENT");
+            }
+          return 0;
+#endif
+          break;
+
+
         default:
         case TOKEN_BAD:
           break;
@@ -606,6 +735,16 @@
   sendto_one(sptr, ":%s NOTICE %s :Options: IDLETIME",
              me.name, parv[0]);
 #endif
+#ifdef CHECK_CLONE
+  sendto_one(sptr, ":%s NOTICE %s :Options: CLONENUM CLONEPERIOD",
+             me.name, parv[0]);
+#endif
+#ifdef XLINE_COMMAND
+  sendto_one(sptr, ":%s NOTICE %s :Options: XLINETYPE",
+             me.name, parv[0]);
+#endif
+  sendto_one(sptr, ":%s NOTICE %s :Options: MAXTKTIME",
+             me.name, parv[0]);
   sendto_one(sptr, ":%s NOTICE %s :Options: LOG",
              me.name, parv[0]);
   return 0;
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_stats.c ircd-hybrid-6.3.1/src/m_stats.c
--- ircd-hybrid-6.3.1.dist/src/m_stats.c	Wed Dec 19 18:24:46 2001
+++ ircd-hybrid-6.3.1/src/m_stats.c	Tue Apr 22 09:35:17 2003
@@ -273,14 +273,17 @@
       valid_stats++;
       break;
     case 'C' : case 'c' :
-#ifdef SERVERHIDE
+#if defined(SERVERHIDE) || defined(C_LINES_OPER_ONLY)
       if (!IsAnOper(sptr))
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
-      else
 #endif
       report_configured_links(sptr, CONF_CONNECT_SERVER|CONF_NOCONNECT_SERVER);
       valid_stats++;
@@ -293,6 +296,7 @@
           break;
         }
       report_dlines(sptr);
+      report_temp_dlines(sptr);
       valid_stats++;
       break;
 
@@ -312,6 +316,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
 #ifdef GLINES
@@ -329,9 +337,12 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
-      else
 #endif
       report_configured_links(sptr, CONF_HUB|CONF_LEAF);
       valid_stats++;
@@ -343,6 +354,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
 #endif /* I_LINES_OPER_ONLY */
@@ -356,6 +371,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
 #endif /* K_LINES_OPER_ONLY */
@@ -369,6 +388,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
 #endif /* K_LINES_OPER_ONLY */
@@ -396,6 +419,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
 #endif /* O_LINES_OPER_ONLY */
@@ -409,6 +436,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
 #endif /* P_LINES_OPER_ONLY */
@@ -427,6 +458,10 @@
       {
 	ignore_request++;
 	valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
 	break;
       }
       report_juped_channels(sptr);
@@ -449,6 +484,10 @@
 	{
 	  ignore_request++;
 	  valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
 	  break;
 	}
       send_usage(sptr,parv[0]);
@@ -473,19 +512,6 @@
       valid_stats++;
       break;
 
-    case 'U' :
-#ifdef U_LINES_OPER_ONLY
-      if (!IsAnOper(sptr))
-      {
-        ignore_request++;
-        valid_stats++;
-        break;
-      }
-#endif /* U_LINES_OPER_ONLY */
-      report_specials(sptr,CONF_ULINE,RPL_STATSULINE);
-      valid_stats++;
-      break;
-
     case 'u' :
       {
         time_t now;
@@ -505,6 +531,10 @@
         {
           ignore_request++;
           valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
           break;
         }
       show_servers(sptr);
@@ -517,7 +547,14 @@
           report_specials(sptr,CONF_XLINE,RPL_STATSXLINE);
           valid_stats++;
         }
-      break;;
+#ifdef STATS_IGNORED_NOTICE
+        else
+        {
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+        }
+#endif
+      break;
 
     case 'Y' : case 'y' :
       if(IsAnOper(sptr))
@@ -525,6 +562,13 @@
           report_classes(sptr);
           valid_stats++;
         }
+#ifdef STATS_IGNORED_NOTICE
+        else
+        {
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+        }
+#endif
       break;
 
     case 'Z' : case 'z' :
@@ -538,6 +582,18 @@
       break;
 
     case '?':
+#ifdef STATS_QMARK_OPER_ONLY
+      if (!IsAnOper(sptr))
+        {
+          ignore_request++;
+          valid_stats++;
+#ifdef STATS_IGNORED_NOTICE
+          sendto_one(sptr, form_str(ERR_STATSIGNORED), me.name, parv[0],
+                     statcmd);
+#endif
+          break;
+        }
+#endif /* STATS_QMARK_OPER_ONLY */
       serv_info(sptr, parv[0]);
       valid_stats++;
       break;
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_unkline.c ircd-hybrid-6.3.1/src/m_unkline.c
--- ircd-hybrid-6.3.1.dist/src/m_unkline.c	Sun Feb 17 00:58:13 2002
+++ ircd-hybrid-6.3.1/src/m_unkline.c	Fri May  2 11:38:44 2003
@@ -36,6 +36,7 @@
 #include "s_conf.h"
 #include "s_log.h"
 #include "s_misc.h"
+#include "s_serv.h"
 #include "send.h"
 #include "struct.h"
 #ifdef GLINES
@@ -50,7 +51,8 @@
 extern ConfigFileEntryType ConfigFileEntry; /* defined in ircd.c */
 
 static int flush_write(aClient *, FBFILE* , char *, char *);
-static int remove_tkline_match(char *,char *, unsigned long);
+int remove_tkline_match(char *,char *, unsigned long);
+static int remove_tdline(unsigned long);
 
 /*
 ** m_unkline
@@ -86,6 +88,17 @@
   ircsprintf(temppath, "%s%s.tmp", ConfigFileEntry.dpath,
 	     ConfigFileEntry.klinefile);
   
+#ifdef HUB
+  if(IsServer(cptr))
+    {
+      if(parc == 4)
+        sendto_match_cap_servs(NULL, cptr, CAP_UNKLN,
+               ":%s UNKLINE %s %s %s",
+               parv[0], parv[1], parv[2], parv[3]);
+      return 0;
+    }
+#endif
+
   if (check_registered(sptr))
     {
       return -1;
@@ -383,7 +396,7 @@
 * un-kline a temporary k-line. 
 *
 */
-static int remove_tkline_match(char *host,char *user, unsigned long ip)
+int remove_tkline_match(char *host,char *user, unsigned long ip)
 {
   aConfItem *kill_list_ptr;
   aConfItem *last_kill_ptr=(aConfItem *)NULL;
@@ -442,6 +455,39 @@
   }
 }
 
+/* remove_tdline()
+ *
+ * inputs	- ip of dline to remove
+ * output	-
+ * side effects - dline, if found, is removed
+ */
+static int remove_tdline(unsigned long ip)
+{
+    struct ConfItem *ptr;
+    struct ConfItem *last_ptr = NULL;
+
+    if(!temporary_dlines)
+	return NO;
+
+    for(ptr = temporary_dlines; ptr; ptr = ptr->next)
+    {
+	if((ip & ptr->ip_mask) == ptr->ip)
+	{
+	    if(last_ptr)
+		last_ptr->next = ptr->next;
+	    else
+		temporary_dlines = ptr->next;
+
+	    free_conf(ptr);
+	    return YES;
+	}
+	
+	last_ptr = ptr;
+    }
+
+    return NO;
+}
+
 /*
 ** m_undline
 ** added May 28th 2000 by Toby Verrall <toot@melnet.co.uk>
@@ -505,6 +551,18 @@
       return 0;
     }
 
+  if((remove_tdline(ip_host)))
+  {
+      sendto_one(sptr, ":%s NOTICE %s :Temporary D-line for [%s] is removed",
+		 me.name, parv[0], cidr);
+
+      sendto_ops("%s has removed the temporary D-line for: [%s]", parv[0], cidr);
+      log(L_NOTICE, "%s has removed temporary D-line for [%s]", parv[0], cidr);
+
+      return 0;
+  }
+
+		
   filename = get_conf_name(DLINE_TYPE);
 
   if( (in = fbopen(filename, "r")) == 0)
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_userhost.c ircd-hybrid-6.3.1/src/m_userhost.c
--- ircd-hybrid-6.3.1.dist/src/m_userhost.c	Tue Jan  2 00:48:18 2001
+++ ircd-hybrid-6.3.1/src/m_userhost.c	Sat Apr 19 21:06:45 2003
@@ -130,6 +130,14 @@
 
       if ((acptr = find_person(cn, NULL)))
         {
+#ifdef REVERT_USERHOST
+          rl = ircsprintf(response, "%s%s=%c%s@%s ",
+                       acptr->name,
+                       IsAnOper(acptr) ? "*" : "",
+                       (acptr->user->away) ? '-' : '+',
+                       acptr->username,
+                       acptr->host);
+#else
           if (acptr == sptr) /* show real IP for USERHOST on yourself */
             rl = ircsprintf(response, "%s%s=%c%s@%s ",
 		       acptr->name,
@@ -144,6 +152,7 @@
 		       (acptr->user->away) ? '-' : '+',
 		       acptr->username,
 		       acptr->host);
+#endif
 
           if((rl + cur_len) < (BUFSIZE-10))
             {
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_wallops.c ircd-hybrid-6.3.1/src/m_wallops.c
--- ircd-hybrid-6.3.1.dist/src/m_wallops.c	Wed Oct 17 11:13:31 2001
+++ ircd-hybrid-6.3.1/src/m_wallops.c	Sat Apr 19 21:06:45 2003
@@ -120,7 +120,7 @@
 
   if(!IsServer(sptr))   /* If source of message is not a server, i.e. oper */
     {
-      send_operwall(sptr, "WALLOPS", message);
+      send_operwall(sptr, "WALLOPS", message, 0);
       sendto_serv_butone( IsServer(cptr) ? cptr : NULL,
                           ":%s WALLOPS :%s", parv[0], message);
     }
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_whois.c ircd-hybrid-6.3.1/src/m_whois.c
--- ircd-hybrid-6.3.1.dist/src/m_whois.c	Wed Jun  6 02:56:34 2001
+++ ircd-hybrid-6.3.1/src/m_whois.c	Thu May  8 13:26:33 2003
@@ -143,6 +143,7 @@
       parv[1] = parv[2];
     }
 
+#if (WHOIS_WAIT > 0)
   if(!IsAnOper(sptr) && !MyConnect(sptr)) /* pace non local requests */
     {
       if((last_used + WHOIS_WAIT) > CurrentTime)
@@ -151,6 +152,10 @@
            * request =might= increase sendq to be usable in a split hack
            * Sorry gang ;-( - Dianora
            */
+#ifdef WHOIS_TRYAGAIN
+          sendto_one(sptr, form_str(RPL_LOAD2HI), me.name, parv[0],
+                     "WHOIS");
+#endif
           return 0;
         }
       else
@@ -158,6 +163,7 @@
           last_used = CurrentTime;
         }
     }
+#endif
 
   /* Multiple whois from remote hosts, can be used
    * to flood a server off. One could argue that multiple whois on
@@ -283,13 +289,35 @@
           if (IsAnOper(acptr))
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
                        me.name, parv[0], name);
+
 #ifdef WHOIS_NOTICE
+#ifdef REMOTE_WHOIS_NOTICE
+          if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
+              (IsPerson(sptr)) && (acptr != sptr))
+            {
+              if (MyConnect(sptr))
+                {
+                  sendto_one(acptr,
+                             ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
+                             me.name, acptr->name, parv[0], sptr->username,
+                             sptr->host);
+                }
+              else
+                {
+                  sendto_one(acptr,
+                             ":%s NOTICE %s :*** Notice -- %s (%s@%s) [%s] is doing a remote /whois on you.",
+                             me.name, acptr->name, parv[0], sptr->username,
+                             sptr->host, sptr->user->server);
+                }
+            }
+#else
           if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
               (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
             sendto_one(acptr,
                        ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
                        me.name, acptr->name, parv[0], sptr->username,
                        sptr->host);
+#endif /* REMOTE_WHOIS_NOTICE */
 #endif /* #ifdef WHOIS_NOTICE */
 
 
@@ -298,10 +326,21 @@
               && IsAnOper(sptr)
 #endif
               && MyConnect(acptr)))
+          {
+            /* This test SHOULD be sufficient */
+#ifdef HIDE_SPOOF_IPS
+            if (!IsIPSpoof(acptr) || (sptr==acptr))
+#else
+            if (!IsIPSpoof(acptr) || (IsAnOper(sptr)) || (sptr==acptr))
+#endif
+              sendto_one(sptr, form_str(RPL_WHOISACTUALLY),
+                         me.name, parv[0], name,
+                         acptr->sockhost);
             sendto_one(sptr, form_str(RPL_WHOISIDLE),
                        me.name, parv[0], name,
                        CurrentTime - user->last,
                        acptr->firsttime);
+          }
           sendto_one(sptr, form_str(RPL_ENDOFWHOIS), me.name, parv[0], parv[1]);
           return 0;
           /*      continue; */
@@ -426,13 +465,35 @@
           if (IsAnOper(acptr))
             sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
                        me.name, parv[0], name);
+
 #ifdef WHOIS_NOTICE
+#ifdef REMOTE_WHOIS_NOTICE
+          if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
+              (IsPerson(sptr)) && (acptr != sptr))
+            {
+              if (MyConnect(sptr))
+                {
+                  sendto_one(acptr,
+                             ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
+                             me.name, acptr->name, parv[0], sptr->username,
+                             sptr->host);
+                }
+              else
+                {
+                  sendto_one(acptr,
+                             ":%s NOTICE %s :*** Notice -- %s (%s@%s) [%s] is doing a remote /whois on you.",
+                             me.name, acptr->name, parv[0], sptr->username,
+                             sptr->host, sptr->user->server);
+                }
+            }
+#else
           if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
               (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
             sendto_one(acptr,
                        ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
                        me.name, acptr->name, parv[0], sptr->username,
                        sptr->host);
+#endif /* REMOTE_WHOIS_NOTICE */
 #endif /* #ifdef WHOIS_NOTICE */
 
           if ((acptr->user
